### PARALLEL DJIKSTRA'S ALGORITHM CUDA IF3230
## Petunjuk penggunaan program

1. Buka terminal
2. Pada terminal, ketik "make"
3. Lalu untuk melakukan run, ketik "./djikstra"

## Pembagian tugas:

13516153 - Sendiri :(

## Pengujian:

### Deskripsi solusi paralel. Berikan ilustrasi jika perlu.
Solusi paralel yang dibuat adalah dengan membagi pekerjaan sekuensial ke dalam beberapa proses untuk dilakukan secara paralel.
Untuk melakukan eksekusi pada <i>device</i> (GPU), data array pada <i>host</i> (CPU) harus disalin menggunakan <i>cudaMemcpy</i>.
Pekerjaan yang dibagi adalah:

1. Pembangkitan nilai acak pada array menggunakan <i>cudaRand</i>.
2. Pencarian nilai maksimum untuk menentukan digit terbesar diantara elemen array. Pencarian dilakukan dengan pararel yang direduksi, menggunakan <i>CUDA threads</i>.
3. Perhitungan kemunculan angka pada setiap digit. Pembagian dilakukan dengan mengelompokkan masing-masing elemen array kepada digit tertentu menggunakan <i>CUDA threads</i>, kemudian masing-masing thread menggabungkan hasil perhitungan ke dalam sebuah <i>bucket</i> global (yang menyimpan seluruh kemunculan digit) dengan memanfaatkan <i>atomicAdd</i> sebagai implementasi dari <i>critical section</i>.

Setelah perhitungan kemunculan angka telah digabung, array pada <i>device</i> disalin ke array pada <i>host</i> untuk dilakukan pemetaan elemen array berdasarkan kemunculan angka pada digit yang sedang diperiksa.
Lalu pengulangan dilakukan dari digit terkecil hingga digit terbesar.


### Analisis solusi yang anda berikan. Apakah mungkin terdapat solusi yang memberikan kinerja lebih baik?
Solusi yang dibuat dapat mempercepat kinerja dengan membagi pekerjaan. Ilustrasinya apabila terdapat 50 elemen array, maka sebanyak 25 <i>CUDA thread</i> digunakan untuk melakukan 1 kali perbandingan elemen, berbeda dengan eksekusi di <i>host</i> yang harus melakukan perbandingan sebanyak 100 kali menggunakan 1 CPU thread. Waktu perhitungan kemunculan angka pada setiap digit juga tereduksi karena setiap <i>CUDA thread</i> melakukan pengelompokkan digit untuk setiap elemen pada array.
Mungkin saja terdapat solusi lain yang lebih cepat. Untuk pemetaan elemen array yang dilakukan oleh proses utama, mungkin saja dapat diparallelkan, tetapi algoritma yang telah dibuat tidak menerapkannya.
Tetapi tentu saja tidak menutup kemungkinan terdapat solusi lain yang lebih cepat. Untuk pemetaan elemen array yang dilakukan oleh proses utama, mungkin saja dapat diparalelkan, tetapi algoritma yang telah dibuat tidak menerapkannya.

### Jelaskan pemetaan thread ke komputasi, dan jumlah thread per block yang digunakan. Kenapa anda memilih angka tersebut?
Thread yang digunakan untuk menentukan nilai maksimum pada array adalah sebanyak <i>N/2</i>, dengan <i>N</i> adalah banyak elemen array. Hal ini dilakukan karena dengan algoritma yang digunakan, setiap thread melakukan perbandingan satu elemen array dengan satu elemen lainnya.
Thread yang digunakan untuk melakukan sorting pada array adalah sebanyak <i>N</i>. Setiap thread bertugas untuk mengelompokkan setiap elemen array pada <i>bucket</i> digit yang ada.

### Pengukuran kinerja untuk tiap kasus uji (jumlah N pada array) dibandingkan dengan djikstra's algorithm serial.

Untuk pengujian setiap N, perlu pengubahan nilai konstanta N_uji pada program.

#### N = 100

Serial : Waktu eksekusi: 3825 microseconds

Parallel : Waktu eksekusi: 5575 microseconds

#### N = 500

Serial : Waktu eksekusi: 17623 microseconds

Parallel : Waktu eksekusi: 17422 microseconds

#### N = 1000

Serial : Waktu eksekusi: 22458 microseconds

Parallel : Waktu eksekusi: 22133 microseconds

#### N = 3000

Serial : Waktu eksekusi: 42411 microseconds

Parallel : Waktu eksekusi: 37665 microseconds

#### Analisis perbandingan kinerja serial dan paralel. Analisis yang diharapkan adalah analisis yang minimal dapat menjelaskan setiap hasil pengukuran kinerja sebelumnya.
Untuk parameter <b>N</b> yang kecil (pada kasus ini 100 dan 500), waktu eksekusi paralel lebih lama dibandingkan dengan waktu eksekusi serial. Ini berarti program perlu dioptimasi dengan mengubah algoritma dalam memetakan array setelah perhitungan kemunculan angka tiap digit. Dan juga perlu dianalisis lebih lanjut mengenai <i>stride</i> pada algoritma untuk dapat memanfaatkan pengaksesan memori yang lebih efisien.